IMPLEMENTATION MODULE AsciiTime;

  (*------------------------------------------------------------------------*)
  (* Prepare string for printout of date and time                           *)
  (*------------------------------------------------------------------------*)
  (* Letzte Bearbeitung                                                     *)
  (*                                                                        *)
  (* 11.06.2015: Erstellen der 1. Version                                   *)
  (* 15.01.2017: Komplett neue Version erstellt                             *)
  (*------------------------------------------------------------------------*)
  (* Licence : GNU Lesser General Public License (LGPL)                     *)
  (*------------------------------------------------------------------------*)

  (* $Id: AsciiTime.mod,v 1.3 2018/01/15 16:41:44 mriedl Exp mriedl $ *)

FROM SysClock IMPORT DateTime;
              IMPORT Strings;

VAR   ConvStr : ARRAY [0..10] OF CHAR;

PROCEDURE Insert(VAR str : ARRAY OF CHAR;
                     n   : CARDINAL;
                     pos : CARDINAL);

          CONST b = 10;
BEGIN
      REPEAT
        str[pos] := ConvStr[n MOD b];
        n:=n DIV b;
        DEC(pos);
      UNTIL (n = 0);
END Insert;

PROCEDURE DateStr(VAR str  : ARRAY OF CHAR;
                      time : DateTime;
                      rev  : BOOLEAN);
BEGIN
      IF rev THEN    (* 0123456679 *)
        Strings.Assign("0000:00:00",str);
        Insert(str,time.year,3);
        Insert(str,time.month,6);
        Insert(str,time.day,9);
      ELSE           (* 0123456679 *)
        Strings.Assign("00:00:0000",str);
        Insert(str,time.day,1);
        Insert(str,time.month,4);
        Insert(str,time.year,9);
      END;
END DateStr;

PROCEDURE TimeStr(VAR str  : ARRAY OF CHAR;
                      time : DateTime);

BEGIN              (* 01234567 *)
      Strings.Assign("00:00:00",str);
      Insert(str,time.hour,1);
      Insert(str,time.minute,4);
      Insert(str,time.second,7);
END TimeStr;

BEGIN
       ConvStr := "0123456789";
END AsciiTime.
