IMPLEMENTATION MODULE FIO2;

  (*------------------------------------------------------------------------*)
  (* Fileorientierte Lese- und Schreibprozeduren                            *)
  (*                                                                        *)
  (* Letzte Bearbeitung :                                                   *)
  (*                                                                        *)
  (* 07.10.96, MRi: Fehlerkorrekturen.                                      *)
  (* 30.07.98, MRi: Einf"uhrung der globalen Variable warn, um              *)
  (*                Warnungen unterdr"ucken zu k"onnen.                     *)
  (* 15.03.15, MRi: Fehler in WrBin korrigiert                              *)
  (* 05.05.15, MRi: Fehler in RdBin entsprechend korrigiert                 *)
  (* 04.06.15, MRi: Prozeduren WrLngInt und WrReal eingef"uhrt.             *)
  (* 26.08.15, MRi: Prozeduren ReadLine eingef"uhrt.                        *)
  (* 24.11.16, MRi: Prozeduren WrBits eingef"uhrt.                          *)
  (* 17.06.17, MRi: Prozeduren WrBool eingef"uhrt.                          *)
  (* 25.07.17, MRi: In Prozedur RdWord warnold etc ingef"uhrt.              *)
  (*                WrLngCmplx auf ISO umgestellt                           *)
  (*------------------------------------------------------------------------*)
  (* Offene Punkte                                                          *)
  (*                                                                        *)
  (* - EOF/EOL eventuell als Prozedur definieren die an einen Datei-        *)
  (*   deskriptor gebunden ist.                                             *)
  (* - Die Varibale ExpAnz in einer Prozedur nach aussen kapseln            *)
  (*------------------------------------------------------------------------*)
  (* Licence : GNU Lesser General Public License (LGPL)                     *)
  (*------------------------------------------------------------------------*)
 
  (* $Id: FIO2.mod,v 1.1.1.1 2017/07/25 14:45:47 mriedl Exp mriedl $ *)

FROM SYSTEM      IMPORT BYTE,TSIZE;
                 IMPORT ASCII,CommonIO;
FROM ConvTypes   IMPORT ConvResults;
FROM Errors      IMPORT Fehler,Fehlerflag,ErrOut;
FROM StringsLib  IMPORT Concat,Length;
FROM FileSystem  IMPORT File,WriteNBytes,ReadNBytes;
                 IMPORT FileSystem;
FROM NumConvert  IMPORT IntToString,StringToInt,LongIntToString,
                        CardToString,StringToCard,
                        CardToStrBased,StrToCardBased,CardToBitStr,
                        LongCardToString,StringToLongCard;
FROM RealConvert IMPORT StringToReal,RealToFloatString,RealToFixString;

(*--------------- Globale Objekte -----------------------------------*)

CONST     MaxCardStr      = 15;
          MaxLngCardStr   = 31;
          MaxIntStr       = 15;
          MaxRealStr      = 63;
          MaxTrennZeichen =  5;

VAR       RealStr     : ARRAY [0..MaxRealStr] OF CHAR;
          CardStr     : ARRAY [0..MaxCardStr] OF CHAR;
          LngCardStr  : ARRAY [0..MaxLngCardStr] OF CHAR;
          IntStr      : ARRAY [0..MaxIntStr]  OF CHAR;
          done        : BOOLEAN;
          result      : ConvResults;
          FFlag       : ARRAY [strAllRight..strEmpty] OF
                        ARRAY [0..31] OF CHAR;
          Trenner     : ARRAY [1..MaxTrennZeichen] OF CHAR;
          TrennAnzahl : CARDINAL; (* Anzahl der aktuell benutzten Trenner *) 

(*-------------------------------------------------------------------*)

PROCEDURE IstTrennZeichen(chr : CHAR) : BOOLEAN;

          VAR i : CARDINAL;
BEGIN
      FOR i:=1 TO TrennAnzahl DO
        IF (chr = Trenner[i]) THEN RETURN TRUE; END;
      END;
      RETURN FALSE; 
END IstTrennZeichen; 

PROCEDURE RdWort(    Ein  : File;
                 VAR Wort : ARRAY OF CHAR);

          VAR i,Laenge    : CARDINAL;
              Chr         : CHAR;
              warnold     : BOOLEAN;
BEGIN
      warnold:=warn; warn:=FALSE;
      REPEAT
        RdChar(Ein,Chr);
        IF EOF THEN Wort[0]:=0C; RETURN; END;
      UNTIL NOT IstTrennZeichen(Chr); 
      Wort[0]:=Chr; i:=1; Laenge:=HIGH(Wort);
      LOOP
        IF (i = Laenge) THEN EXIT END;
        RdChar(Ein,Chr);
        IF IstTrennZeichen(Chr) OR EOL THEN EXIT; END;
        Wort[i]:=Chr;
        INC(i);
      END;
      Wort[i]:=0C; (* Endmarkierung *)
      warn:=warnold;
END RdWort;

PROCEDURE ReadLine(VAR Ein : File; VAR Line : ARRAY OF CHAR); 

          VAR i : CARDINAL;
BEGIN
      i:=0;
      LOOP
        RdChar(Ein,Line[i]);
        IF EOL THEN EXIT; END;
        IF (i = HIGH(Line)) THEN
          Line[i]:=0C;
          ErrOut("Zeilenstring zu kurz (FIO2.ReadLine)");
          RETURN;
        END;
        INC(i);
      END;
      Line[i]:=0C;
END ReadLine;

PROCEDURE WrLn(Datei : File);

BEGIN
      IF CommonIO.CrLf THEN WrChar(Datei,ASCII.cr); END;
      WrChar(Datei,ASCII.lf);
END WrLn;

PROCEDURE WrLnN(Datei : File;
                n     : CARDINAL);  (* Anzahl der Zeilenumbr"uche. *)

          (*---------------------------------------------------------*)
          (* Schreibt n End-of-Line Marke auf die Textdatei 'Datei'. *)
          (*---------------------------------------------------------*)

          VAR         i     : CARDINAL;
BEGIN
      FOR i:=1 TO n DO WrLn(Datei); END;
END WrLnN;

PROCEDURE RdChar(    Ein : File;
                 VAR chr : CHAR);

          VAR Fehler       : BOOLEAN;
              i            : CARDINAL;
              done,warnold : BOOLEAN;
BEGIN
warnold:=FileSystem.CheckIO;
FileSystem.CheckIO:=FALSE;
      chr:="";
      Fehler:=FALSE; EOL:=FALSE; EOF:=FALSE;
      ReadNBytes(Ein,chr,1,i); 
      done := i = 1;
      IF NOT done AND warn THEN ErrOut(" Lesefehler in FIO.RdChar !"); END;
      IF CommonIO.CrLf AND (chr = ASCII.cr) THEN
        (* Sollte unter UNIX nicht vorkommen ! *)
        ReadNBytes(Ein,chr,1,i);
        IF (chr = ASCII.lf) THEN
          chr:=CommonIO.EoL; (* EOL *)
          EOL:=TRUE;
        ELSE
          Fehler:=TRUE;
        END;
      ELSIF (chr = ASCII.lf) THEN
        IF CommonIO.CrLf THEN
          ReadNBytes(Ein,chr,1,i);
          IF (chr = ASCII.cr) THEN
            chr:=CommonIO.EoL; (* EOL *)
            EOL:=TRUE;
          ELSE
            Fehler:=TRUE;
          END;
        ELSE (* UNIX *)
          chr:=CommonIO.EoL; EOL:=TRUE;
        END;
      ELSIF (i # 1) THEN
        chr:=CommonIO.EoF; (* EOF *)
        EOF:=TRUE;
        EOL:=TRUE;
      END;
FileSystem.CheckIO:=warnold;
      IF Fehler AND warn THEN ErrOut('Fehler in FIO.RdChar'); END;
END RdChar;

PROCEDURE WrChar(Datei  : File;
                 chr    : CHAR);

          VAR  i    : CARDINAL;
BEGIN
      IF (chr = CommonIO.EoL) THEN
        IF CommonIO.CrLf THEN WrChar(Datei,ASCII.cr); END;
        (* WrChar(Datei,ASCII.lf); Endlosrekursion f"ur EoL=ASCII.lf *) 
        chr:=ASCII.lf; WriteNBytes(Datei,chr,1,i); 
      ELSE
        WriteNBytes(Datei,chr,1,i); 
      END;
END WrChar;

PROCEDURE WrCharN(VAR Aus    : File;
                      chr    : CHAR;
                      Anzahl : CARDINAL);

          CONST puflen = 31;

          VAR puf : ARRAY [0..puflen] OF CHAR; (* Puffer *)
              i,j : CARDINAL;
BEGIN
      WHILE (Anzahl > 0) DO
        i :=puflen;
        IF (i > Anzahl) THEN i := Anzahl; END;
        DEC(Anzahl,i);
        j := 0;
        WHILE (j < i) DO puf[j] := chr; INC(j) END;
        puf[j] := 0C;
        WrStr(Aus,puf);
      END;
END WrCharN;

PROCEDURE RdStr(    Datei : File;
                VAR Wort  : ARRAY OF CHAR);

          VAR  i   : CARDINAL;
               chr : CHAR;
BEGIN
      i:=0;
      LOOP
        RdChar(Datei,chr);
        IF EOL THEN EXIT END;
        Wort[i]:=chr;
        INC(i);
        IF (i = HIGH(Wort)) THEN EXIT END;
      END; (* LOOP *)
      Wort[i]:=0C;
END RdStr;

PROCEDURE  WrStr(Datei  : File;
                 Wort   : ARRAY OF CHAR);

          (*---------------------------------------*)
          (* Schreibt den String Wort auf die      *)
          (* Text-Datei Datei.                     *)
          (*---------------------------------------*)

          VAR  i,j : CARDINAL;
BEGIN
      i:=Length(Wort);
      IF (i > 1024) THEN
        ErrOut('Stringl"ange gr"o\3er als 1024 (FIO.WrStr) !');
      END; 
      WriteNBytes(Datei,Wort,i,j);
      IF (j < i) THEN
        DiskFull:=TRUE;
        Fehler:=TRUE; Fehlerflag:='Platte / Diskette voll (FIO.WrStr) !';
        ErrOut(Fehlerflag);
      END;
END WrStr;

PROCEDURE WrStrForm(VAR Aus    : File;
                        Str    : ARRAY OF CHAR;
                        Breite : INTEGER);

          VAR  len,fuell : INTEGER;
BEGIN
      len := Length(Str);
      fuell := ABS(Breite) - len;
      IF (Breite > 0) AND (fuell > 0) THEN WrCharN(Aus,' ',fuell); END;
      WrStr(Aus,Str);
      IF (Breite < 0) AND (fuell > 0) THEN WrCharN(Aus,' ',fuell); END;
END WrStrForm;

PROCEDURE RdCard(    Datei  : File;
                 VAR c      : CARDINAL);

BEGIN
      RdWort(Datei,CardStr);
      StringToCard(CardStr,c,result);
      IF (result # strAllRight) THEN
        Concat(Fehlerflag,FFlag[result]," (FIO.RdCard) !");
        ErrOut(Fehlerflag);
        c:=MAX(CARDINAL);
        RETURN;
      END;
END RdCard;

PROCEDURE WrCard(Datei  : File;
                 c      : CARDINAL;
                 n      : CARDINAL);  (* Feldbreite *)

          VAR ZahlStr : ARRAY [0..15] OF CHAR;
BEGIN
      CardToString(c,n,ZahlStr,done);
      WrStr(Datei,ZahlStr);
END WrCard;

PROCEDURE RdHex(    Datei  : File;
                VAR c      : CARDINAL);

          VAR  CardStr : ARRAY [0..15] OF CHAR;
               C       : LONGCARD;
BEGIN
      RdWort(Datei,CardStr);
      StrToCardBased(CardStr,16,C,result);
      IF (result # strAllRight) THEN
        Concat(Fehlerflag,FFlag[result]," (Streams.RdCard) !");
        ErrOut(Fehlerflag);
        c:=MAX(CARDINAL);
        RETURN;
      END;
      IF (C > VAL(LONGCARD,MAX(CARDINAL))) THEN
        Concat(Fehlerflag,FFlag[strOutOfRange]," (Streams.RdHex) !");
        ErrOut(Fehlerflag);
        c:=MAX(CARDINAL);
        RETURN;
      END;
      c := VAL(CARDINAL,C);
END RdHex;

PROCEDURE WrHex(Datei  : File;
                c      : CARDINAL;
                n      : CARDINAL);  (* Feldbreite *)

          VAR ZahlStr : ARRAY [0..15] OF CHAR;
              done    : BOOLEAN;
              len,i   : CARDINAL;
BEGIN
      CardToStrBased(VAL(LONGCARD,c),ZahlStr,16,done);
      len := Length(ZahlStr);
      FOR i:=1 TO (n - len) DO WrChar(Datei," "); END;
      WrStr(Datei,ZahlStr);
END WrHex;

PROCEDURE WrBits(Datei : File;
                 c     : CARDINAL;
                 nbits : CARDINAL);  (* Feldbreite *)
          
          VAR Str : ARRAY [0..127] OF CHAR;
BEGIN
      CardToBitStr(c,Str,nbits); 
      WrStr(Datei,Str);
END WrBits;

PROCEDURE RdOct(    Datei  : File;
                VAR c      : CARDINAL);

          VAR  CardStr : ARRAY [0..15] OF CHAR;
               C       : LONGCARD;
BEGIN
      RdWort(Datei,CardStr);
      StrToCardBased(CardStr,8,C,result);
      IF (result # strAllRight) THEN
        Concat(Fehlerflag,FFlag[result]," (Streams.RdCard) !");
        ErrOut(Fehlerflag);
        c:=MAX(CARDINAL);
        RETURN;
      END;
      IF (C > VAL(LONGCARD,MAX(CARDINAL))) THEN
        Concat(Fehlerflag,FFlag[strOutOfRange]," (Streams.RdHex) !");
        ErrOut(Fehlerflag);
        c:=MAX(CARDINAL);
        RETURN;
      END;
      c := VAL(CARDINAL,C);
END RdOct;

PROCEDURE WrOct(Datei  : File;
                c      : CARDINAL;
                n      : CARDINAL);  (* Feldbreite *)

          VAR ZahlStr : ARRAY [0..15] OF CHAR;
              done    : BOOLEAN;
              len,i   : CARDINAL;
BEGIN
      CardToStrBased(VAL(LONGCARD,c),ZahlStr,8,done);
      len := Length(ZahlStr);
      FOR i:=1 TO (n - len) DO WrChar(Datei," "); END;
      WrStr(Datei,ZahlStr);
END WrOct;

PROCEDURE RdLngCard(    Datei  : File;
                    VAR C      : LONGCARD);

BEGIN
      RdWort(Datei,LngCardStr);
      StringToLongCard(LngCardStr,C,result);
      IF (result # strAllRight) THEN
        Concat(Fehlerflag,FFlag[result]," (FIO.RdLngCard) !");
        ErrOut(Fehlerflag);
        C:=MAX(LONGCARD);
        RETURN;
      END;
END RdLngCard;

PROCEDURE WrLngCard(Datei  : File;
                    C      : LONGCARD;
                    n      : CARDINAL);  (* Feldbreite *)

          VAR ZahlStr : ARRAY [0..31] OF CHAR;
              done    : BOOLEAN;
BEGIN
      LongCardToString(C,n,ZahlStr,done);
      WrStr(Datei,ZahlStr);
END WrLngCard;

PROCEDURE RdInt(    Datei  : File;
                VAR i      : INTEGER);

BEGIN
      RdWort(Datei,IntStr);
      StringToInt(IntStr,i,result);
      IF (result # strAllRight) THEN
        Concat(Fehlerflag,FFlag[result]," (FIO.RdInt) !");
        ErrOut(Fehlerflag);
        i:=MAX(INTEGER);
        RETURN;
      END;
END RdInt;

PROCEDURE WrInt(Datei  : File;
                i      : INTEGER;
                n      : CARDINAL);  (* Feldbreite *)

          VAR ZahlStr : ARRAY [0..15] OF CHAR;
BEGIN
       IntToString(i,n,ZahlStr,done);
       WrStr(Datei,ZahlStr);
END WrInt;

PROCEDURE WrLngInt(Datei  : File;
                   I      : LONGINT;
                   n      : CARDINAL);  (* Feldbreite *)

          VAR ZahlStr : ARRAY [0..31] OF CHAR;
BEGIN
       LongIntToString(I,n,ZahlStr,done);
       WrStr(Datei,ZahlStr);
END WrLngInt;

PROCEDURE RdLngReal(    Datei  : File;
                    VAR x      : LONGREAL);

BEGIN
      RdWort(Datei,RealStr);
      StringToReal(RealStr,x,result);
      IF (result # strAllRight) THEN
        Concat(Fehlerflag,FFlag[result]," (FIO.RdLngReal) !");
        ErrOut(Fehlerflag);
        x:=MAX(LONGREAL);
      END;
END RdLngReal;

PROCEDURE WrLngReal(Datei  : File;
                    x      : LONGREAL;
                    Breite : CARDINAL; (* n : Feldbreite       *)
                    Komma  : INTEGER); (* m : Nachkommastellen *)

         VAR AllRight : BOOLEAN;
             ZahlStr  : ARRAY [0..MaxRealStr] OF CHAR;
BEGIN
      IF (Breite > MaxRealStr) THEN Breite:=MaxRealStr; END;
      IF (Komma < 0) THEN
        RealToFloatString(ZahlStr,x,Breite,Komma,ExpAnz,AllRight);
      ELSE
        RealToFixString(ZahlStr,x,Breite,VAL(CARDINAL,Komma),AllRight);
      END;
      IF NOT AllRight THEN
(*      WrCharN(Datei,"*",Breite); *)
        WrStr(Datei,ZahlStr);
      ELSE
        WrStr(Datei,ZahlStr);
      END;
END WrLngReal;

PROCEDURE WrReal(Datei  : File;
                 x      : REAL;
                 Breite : CARDINAL; (* n : Feldbreite       *)
                 Komma  : INTEGER); (* m : Nachkommastellen *)
BEGIN
      WrLngReal(Datei,VAL(LONGREAL,x),Breite,Komma);
END WrReal;

PROCEDURE WrLngCmplx(Datei  : File;
                     x      : LONGCOMPLEX;
                     Breite : CARDINAL; (* Feldbreite       *)
                     Komma  : INTEGER); (* Nachkommastellen *)

BEGIN
      WrLngReal(Datei,RE(x),Breite,Komma);
      IF (IM(x) >= 0.0) THEN
        WrStr(Datei,' + i');
      ELSE
        WrStr(Datei,' - i');
      END;
      WrLngReal(Datei,ABS(IM(x)),Breite,Komma);
END WrLngCmplx;

PROCEDURE WrBool(Datei : File;
                 Bool  : BOOLEAN);
BEGIN
      IF Bool THEN WrStr(Datei,' TRUE  '); ELSE WrStr(Datei,' FALSE '); END;
END WrBool;

PROCEDURE RdBin(    Datei  : File;
                VAR Objekt : ARRAY OF BYTE);

          VAR  nbr     : CARDINAL; (* Number of Bytes read *)
               Groesse : CARDINAL; (* Size of Objekt in BYTES *)
BEGIN
      Groesse:=(HIGH(Objekt)+1)*TSIZE(BYTE); (* +1, eingefuegt 07.05.15 *)
      ReadNBytes(Datei,Objekt,Groesse,nbr);
      IF (nbr # Groesse) THEN EOF:=TRUE; ELSE EOF:=FALSE; END;
END RdBin;

PROCEDURE WrBin(    Datei  : File;
                VAR Objekt : ARRAY OF BYTE);

          VAR  nbw     : CARDINAL; (* Number of Bytes written *)
               Groesse : CARDINAL; (* Size of Objekt in BYTES *)
BEGIN
      Groesse:=(HIGH(Objekt)+1)*TSIZE(BYTE); (* +1 Eingefuegt, 15.02.15 *)
      WriteNBytes(Datei,Objekt,Groesse,nbw);
      IF (nbw # Groesse) THEN
        DiskFull:=TRUE;
        Fehler:=TRUE; Fehlerflag:='Schreibfehler (FIO.WrBin)';
        ErrOut(Fehlerflag);
      END;
END WrBin;

BEGIN
      warn:=TRUE;
      done:=TRUE; DiskFull:=FALSE;
      ExpAnz:=3;
      TrennAnzahl:=2;
      Trenner[1]:=" ";
      Trenner[2]:=ASCII.lf;
      IF CommonIO.CrLf THEN
        Trenner[2]:=EoL;       (* Wegen Umsetzen in RdChar *)
        Trenner[3]:=ASCII.cr;
        Trenner[4]:=ASCII.lf;
        Trenner[5]:=ASCII.sub; (* Ctrl-Z *)
        TrennAnzahl := 5;
      END;
      FFlag[strAllRight]    := 'In Ordnung !';
      FFlag[strOutOfRange]  := 'Wertebereichs"uberschreitung !';
      FFlag[strWrongFormat] := 'Falsches Format !';
      FFlag[strEmpty]       := 'Zeichenkette leer !';
END FIO2.
