MODULE Test01;

  (* Einige Beispiele und Tests der InOut-Routinen. *)
  (* M. Riedl, Dezember 1993.                       *)

  (*
   * $Id: Test01.mod,v 1.1 2015/09/13 20:48:42 mriedl Exp mriedl $
   *)

FROM SYSTEM     IMPORT TSIZE,BYTE,CAST;
FROM LongMath   IMPORT pi,sqrt;
FROM FileSystem IMPORT File,Lookup,ReWrite,Close,
                       OpenFlags,OpenMode,AccessFlags,AccessMode,ChMod;
                IMPORT FileSystem,StringsLib,Errors;
FROM FIO2       IMPORT WrStr,WrLn;
                IMPORT TIO;
                IMPORT LongMath;
                IMPORT Streams,SIO;
                IMPORT TFormAus;
                IMPORT SFormAus;
                IMPORT SFormEin;
                IMPORT InOut;
                IMPORT NumConvert;

PROCEDURE Ueberlauf(x : LONGREAL) : LONGREAL;

BEGIN (* Produce overflow when called with MAX(LONGREAL) *)
      x:=LongMath.sqrt(x);
      RETURN LongMath.exp(LongMath.ln(x)*3.0);
EXCEPT
      RETURN LongMath.exp(LongMath.ln(x)*3.0);
END Ueberlauf;

PROCEDURE NoNumber(x : LONGREAL) : LONGREAL;

BEGIN (* Produce NaN when called with zero as argument *)
      RETURN 0.0 / x;
EXCEPT
      RETURN 0.0 / x;
END NoNumber;

VAR   Aus     : File;
      AusS    : Streams.Stream; 
      x       : LONGREAL;
      Str     : ARRAY [0..127] OF CHAR;
      len     : LONGCARD;


BEGIN
      TIO.WrStr("Das ist ein Test der InOut-Routinen");
      TIO.WrLn;

      TIO.WrStr("Gebe eine REAL-Zahl ein (vorgabe : pi) : ");
      TIO.RdRealDefault(x,pi);
      TIO.WrStr("Die eingegebene Zahl war : ");  TIO.WrLngReal(x,12,6);
      TIO.WrLn;
      TIO.WrStr("Das ist ein Test !"); TIO.WrLn;
      TIO.WrStr("Das ist ein weiterer Test !"); TIO.WrLn;

      TIO.WrLn;
      x:=MAX(LONGREAL);
      x:=Ueberlauf(x);
      TIO.WrStr(" sqrt(MAX(LONGREAL))**3  : ");  TIO.WrLngReal(x,12,6);
      TIO.WrLn;
      x:=-x;
      TIO.WrStr("-sqrt(MAX(LONGREAL))**3  : ");  TIO.WrLngReal(x,12,6);
      TIO.WrLn;
      x:=0.0;
      x:=NoNumber(x);
      TIO.WrStr("     0.0 / 0.0           : ");  TIO.WrLngReal(x,12,6);
      TIO.WrLn;
      TIO.ExpAnz:=2;
      x:=MAX(LONGREAL); 
      TIO.WrStr(" MAX(LONGREAL)           : ");  TIO.WrLngReal(x,12,-6);
      TIO.WrLn;
      x:=VAL(LONGREAL,MAX(REAL)); 
      TIO.WrStr(" MAX(REAL)               : ");  TIO.WrLngReal(x,12,-6);
      TIO.WrLn;
      TIO.WrLn;
      Errors.Pause(0);

      NumConvert.CardToBitStr(CAST(CARDINAL,OpenMode{openRDWR}),Str,16);
      TIO.WrStr("OpenMode{openRDWR} = ");
      TIO.WrStr(Str); TIO.WrLnN(2);
 
      Lookup(Aus,"TestF.aus",TRUE,OpenMode{openRDWR});
      IF (Aus = -1) THEN HALT; END;
      ReWrite(Aus);

      WrStr(Aus,"Das ist ein Test !"); WrLn(Aus);
      WrStr(Aus,"Das ist ein weiterer Test !"); WrLn(Aus);

      x := 2.0;

      TFormAus.Write1("//,S,/",'Das ist ein Test (2)!');
      TFormAus.Write2("//,S,F12.6,//",'Das ist die Zahl 2 : ',x);

      TIO.WrStr("Nochmal die Zwei : "); TIO.WrLngReal(x,12,6); TIO.WrLn;
      x:=sqrt(x);
      TIO.WrStr("Wurzel aus Zwei  : "); TIO.WrLngReal(x,12,6); TIO.WrLn;
      x:=2.0;
(*
      FFormAus.dWrite1(Aus,"//,S,//",'Das ist ein Test von FFormAus.dWrite1 !');
      FFormAus.dWrite2(Aus,"//,S,F12.6,//",'Das ist die Zahl 2 : ',x);
 
      FFormAus.dWrite1(Aus,"//,S,//",'Ende der Tests');
 *)

      Close(Aus);

      TIO.WrStr("Rufe OpenStream ... ");
      Streams.OpenStream(AusS,"TestS.aus",TRUE); Streams.SetWrite(AusS);
      TIO.WrStr("fertig ! "); TIO.WrLn;

      SIO.WrStr(AusS,"Das ist ein Test !");          SIO.WrLn(AusS);
      SIO.WrStr(AusS,"Das ist ein weiterer Test !"); SIO.WrLn(AusS);
      SIO.WrStr(AusS,"Das ist die Zahl pi : ");
      SIO.WrLngReal(AusS,LongMath.pi,12,7);          SIO.WrLn(AusS);
      SIO.WrStr(AusS,"Das ist falsch : "); 
      x:=1.0E+100*LongMath.pi;
      SIO.WrLngReal(AusS,x,12,7);                    SIO.WrLn(AusS);

(*
      SFormAus.dWrite1(AusS,
      "//,S,//",'Das ist ein Test von SFormAus.dWrite1 !');
      x:=2.0;
      SFormAus.dWrite2(AusS,"//,S,F12.6,//",'Das ist die Zahl 2 : ',x);

      SFormAus.dWrite1(AusS,"//,S,//",'Ende der Tests');
 *)

      Streams.CloseStream(AusS);
      

      Lookup(Aus,"TestF.aus",FALSE,CAST(OpenMode,OpenMode{openRDONLY}));
      len:=0;
      FileSystem.Length(Aus,len);
      TIO.WrLnN(2); TIO.WrStr('Die Lange der Datei TestF.aus ist : ');
      TIO.WrCard(len,8); TIO.WrStr(' Bytes.'); TIO.WrLnN(2);
(*
      SFormAus.Write3("//,S,C8,S,//",
      'Die Lange der Datei TestF.aus ist : ',len,' Bytes.');
 *)
      Close(Aus);

      (* Einige Tests der String-Routinen ! *)

      Str:="Das ist Test";
      StringsLib.Insert(Str,"ein ",8);
      StringsLib.Append(Str," der Routinen !");
      StringsLib.Insert(Str,"String-",21);
      StringsLib.Concat(Str,Str," ");
(*    StringsLib.Append(Str," "); *)
      TIO.WrChar('"'); TIO.WrStr(Str); TIO.WrChar('"'); TIO.WrLn;
      IF StringsLib.Equal(Str,"Das ist ein Test der String-Routinen ! ") THEN
        TIO.WrStr(" Der Test der String-Routine war erfolgreich !");
      ELSE
        TIO.WrStr(" Der Test der String-Routine war nicht erfolgreich !");
      END;
      TIO.WrLn;

      Errors.Pause(1);
      Errors.WriteString('"');
      Errors.WriteString("Das ist die Zahl pi : ");
      Errors.WriteReal(LongMath.pi);
      Errors.WriteString('"');
      Errors.WriteLn;
      Errors.WriteString('"');
      Errors.WriteString("Das ist die Zahl 231 : ");
      Errors.WriteCard(231);
      Errors.WriteString('"');
      Errors.WriteLn;
      Errors.WriteLn;

END Test01.
