MODULE Test02;

  (*------------------------------------------------------------------------*)
  (* Einige Beispiele und Tests der InOut- und Systemroutinen.              *)
  (*                                                                        *)
  (* Letzte Veraenderung:                                                   *)
  (*                                                                        *)
  (* Dez.  93, MRi: Erstellen der ersten Version                            *)
  (* Dez/                                                                   *)
  (* Jan/  15, MRi: Anpassung an XDS und GNU GNU M2                         *)
  (* 25.09.15, MRi: Einfuegen von DeltaZeitHZr,UserLib,SigTerm              *)
  (*------------------------------------------------------------------------*)

  (* $Id: Test02.mod,v 1.1 2015/09/13 20:48:42 mriedl Exp mriedl $ *)

FROM SYSTEM     IMPORT TSIZE,BYTE,CAST;
FROM LongMath   IMPORT pi,sqrt;
FROM FileSystem IMPORT File,Lookup,ReWrite,Close,
                       OpenFlags,OpenMode,AccessFlags,AccessMode,ChMod;
                IMPORT FileSystem,StringsLib,Errors;
FROM FIO2       IMPORT WrStr,WrLn;
                IMPORT TIO;
                IMPORT LongMath;
FROM SysClock   IMPORT DateTime,CanGetClock,GetClock,IsValidDateTime;
FROM Timer      IMPORT DeltaZeitHZr;
                IMPORT Timer;
                IMPORT AsciiTime;
                IMPORT Streams,SIO;
                IMPORT TFormAus;
                IMPORT FFormAus;
                IMPORT SFormAus;
                IMPORT SFormEin;
                IMPORT InOut;
                IMPORT TestReal;
FROM ArgAccess  IMPORT GetArgCount,GetArgument,FindEnvStr;
FROM UserLib    IMPORT GetUserName,GetFullUserName;
                IMPORT UnixLib;
                IMPORT SigTerm;

PROCEDURE MachEps() : LONGREAL;

          VAR eps,EinsPlusEps : LONGREAL;
BEGIN
      eps:=0.5; EinsPlusEps:=1.5;
      WHILE (EinsPlusEps # 1.0) DO
        eps:=0.49*eps;
        EinsPlusEps:=1.0+eps;
      END;
      RETURN eps;
END MachEps;

PROCEDURE WieVieleBytes(x : ARRAY OF BYTE) : CARDINAL;

BEGIN
      RETURN HIGH(x);
END WieVieleBytes;

VAR   Aus          : File;
      AusS         : Streams.Stream; 
      x            : LONGREAL;
      Str,Name     : ARRAY [0..127] OF CHAR;
      zeit         : DateTime;
      ZeitStr      : ARRAY [0..31] OF CHAR; 
      UserName     : ARRAY [0..63] OF CHAR;
      FullUserName : ARRAY [0..63] OF CHAR;
      char         : CHAR;
      len,T        : LONGCARD;
      i            : INTEGER;
      c            : CARDINAL;
      argc         : SHORTCARD;
      dT           : REAL;
      RStat        : UnixLib.Stat;
BEGIN
      (* Wird nicht weiter genutzt *)

      SigTerm.InitTermProg("Signal 15 erhalten"); 

      dT:=DeltaZeitHZr();

      InOut.WriteLn;
      InOut.WriteString("Das ist ein Test der InOut-Routinen");
      InOut.WriteLn;
      InOut.WriteLn;

      GetUserName(UserName);
      TIO.WrLn;
      TIO.WrStr('Dieser Test wird von Benutzer "'); TIO.WrStr(UserName);
      TIO.WrStr('" durchgefuehrt'); TIO.WrLn; TIO.WrLn;

      GetFullUserName(UserName,FullUserName);
      TIO.WrStr('Dieser Test wird von Benutzer "'); TIO.WrStr(FullUserName);
      TIO.WrStr('" durchgefuehrt'); TIO.WrLn; TIO.WrLn;

      argc:=GetArgCount();

      IF (argc = MAX(SHORTCARD)) THEN
        TIO.WrStr("Es konnten keine Kommandozeilenparameter ermittelt werden");
        TIO.WrLn;
        Errors.Pause(0);
      ELSE
        TIO.WrStr("Die Anzahl der Kommandozeilenparameter ist : "); 
        TIO.WrCard(VAL(CARDINAL,argc),3);
        TIO.WrLn;
        FOR c:=0 TO GetArgCount()-1 DO
          GetArgument(c,Str);
          TIO.WrStr("Das "); TIO.WrCard(c,1); 
          TIO.WrStr(" Argument des Programms ist           : "); 
          TIO.WrStr(Str); TIO.WrLn;
        END;
      END;

      FindEnvStr("USER",Str);
      TIO.WrLn;
      TIO.WrStr("USER = "); TIO.WrStr(Str); 
      TIO.WrLn;
      FindEnvStr("SHELL",Str);
      TIO.WrLn;
      TIO.WrStr("SHELL = "); TIO.WrStr(Str); 
      TIO.WrLn;

      Errors.Pause(1);

      TIO.WrStr("Gebe eine REAL-Zahl ein (vorgabe : pi) : ");
      TIO.RdRealDefault(x,pi);
      TIO.WrStr("Die eingegebene Zahl war         : ");  TIO.WrLngReal(x,12,6);
      TIO.WrLn;
      TIO.WrStr("Gebe eine CARDINAL Zahl ein      : ");
      TIO.RdCard(c);
      TIO.WrStr("Die eingegebene Zahl war         : ");  TIO.WrCard(c,12); 
      TIO.WrLn;
      TIO.WrStr("Gebe eine INTEGER Zahl ein       : ");
      TIO.RdInt(i);
      TIO.WrStr("Die eingegebene Zahl war         : ");  TIO.WrInt(i,12);
      TIO.WrLn;

      TIO.WrLn;
      IF CanGetClock() THEN
         GetClock(zeit);
         IF NOT IsValidDateTime(zeit) THEN
           AsciiTime.DateStr(ZeitStr,zeit,FALSE);
           TIO.WrStr("Das aktuelle Datum ist (JJJJ:MM:TT) : ");
           TIO.WrStr(ZeitStr);
           TIO.WrLn;
           AsciiTime.DateStr(ZeitStr,zeit,TRUE);
           TIO.WrStr("Das aktuelle Datum ist (TT:MM:JJJJ) : ");
           TIO.WrStr(ZeitStr);
           TIO.WrLn;
           AsciiTime.TimeStr(ZeitStr,zeit);
           TIO.WrStr("Die aktuelle Uhrzeit ist (hh:mm:ss) : ");
           TIO.WrStr(ZeitStr);
           TIO.WrLn;
         ELSE
           TIO.WrStr("FEHLER: unzulaessige Zeit");
         END;
         TIO.WrLn;
         TIO.WrLn;
         Timer.GetUserTime(T);
         TIO.WrStr("Sekunden seit 01.01.1970 : ");
         TIO.WrLngCard(T,9);
         TIO.WrLn;
         TIO.WrLn;
      ELSE
        TIO.WrStr("FEHLER: Zeit kann nicht ermittelt werden");
      END;
      TIO.WrLn;

      TIO.WrLn;
      TIO.WrStr("Das ist ein Test !"); TIO.WrLn;
      TIO.WrStr("Das ist ein weiterer Test !"); TIO.WrLn;

      TIO.WrStr("Die Laenge    einer LONGREAL-Zahl ist : ");
      TIO.WrCard(WieVieleBytes(x),3); TIO.WrLn; 
      TIO.WrStr("Die Typgroe3e einer LONGREAL-Zahl ist : ");
      TIO.WrCard(TSIZE(LONGREAL),3); TIO.WrLn; 
      Errors.Pause(2);   

      i:=CAST(INTEGER,OpenMode{openWRONLY}) DIV 2;
      TIO.WrStr("OpenMode{openWRONLY} : ");
      TIO.WrBits(i,16); 
      TIO.WrStr(" = "); TIO.WrInt(i,3); TIO.WrLn;

      i:=CAST(INTEGER,OpenMode{openCREAT}) DIV 2;
      TIO.WrStr("OpenMode{openCREAT}  : ");
      TIO.WrBits(i,16); 
      TIO.WrStr(" = "); TIO.WrInt(i,3); TIO.WrLn;

      Errors.Pause(3);

      Lookup(Aus,"TestF.aus",TRUE,OpenMode{openRDWR});
      IF (Aus = -1) THEN HALT; END;
      ReWrite(Aus);

      i:=CAST(INTEGER,AccessMode{ownerRead}) DIV 2;
      TIO.WrStr("AccessMode{ownerRead}  : ");
      TIO.WrBits(i,16); 
      TIO.WrStr(" = "); TIO.WrInt(i,3); TIO.WrLn;
      i:=CAST(INTEGER,AccessMode{ownerWrite}) DIV 2;
      TIO.WrStr("AccessMode{ownerWrite} : ");
      TIO.WrBits(i,16); 
      TIO.WrStr(" = "); TIO.WrInt(i,3); TIO.WrLn;
      i:=CAST(INTEGER,AccessMode{groupRead}) DIV 2;
      TIO.WrStr("AccessMode{groupRead}  : ");
      TIO.WrBits(i,16); 
      TIO.WrStr(" = "); TIO.WrInt(i,3); TIO.WrLn;
      i:=CAST(INTEGER,AccessMode{ownerRead,ownerWrite,groupRead}) DIV 2;
      TIO.WrStr("-rw-r-----             : ");
      TIO.WrBits(i,16); 
      TIO.WrStr(" = "); TIO.WrInt(i,3); TIO.WrLn;
      TIO.WrLn;
      TIO.WrStr('Setze die Zugriffsrechte fuer TestF.aus auf -rw-r--r--'); 
      TIO.WrLn; 

      ChMod(Aus,AccessMode{ownerRead,ownerWrite,groupRead,otherRead}); 

      WrStr(Aus,"Das ist ein Test !"); WrLn(Aus);
      WrStr(Aus,"Das ist ein weiterer Test !"); WrLn(Aus);

      x := 2.0;
      TFormAus.Write1("//,S,/",'Das ist ein Test (2)!');
      TFormAus.Write2("//,S,F12.6,//",'Das ist die Zahl 2 : ',x);
      TIO.WrStr("Nochmal die Zwei : "); TIO.WrLngReal(x,12,6); TIO.WrLn;
      x:=sqrt(x);
      TIO.WrStr("Wurzel aus Zwei  : "); TIO.WrLngReal(x,12,6); TIO.WrLn;

      x:=MAX(LONGREAL);
      TIO.WrLn;
      TIO.WrStr("MAX(LONGREAL) : "); TIO.WrLngReal(x,12,-6); TIO.WrLn;
      x:=MIN(LONGREAL);
      TIO.WrStr("MIN(LONGREAL) : "); TIO.WrLngReal(x,12,-6); TIO.WrLn;
      TIO.WrStr("MachEps       : "); TIO.WrLngReal(MachEps(),12,-6); TIO.WrLn;

(*
      TIO.WrStr("INF           : "); TIO.WrLngReal(TestReal.Real8INF(),12,-6);
      TIO.WrLn;

      (* Prfen ob NaN abgefangen wird ...  RealConversion durchsehen !!!  *)

      TIO.WrStr("NaN           : "); TIO.WrLngReal(TestReal.Real8NaNquite(),12,-6);
      TIO.WrLn;
 *)

      FFormAus.dWrite1(Aus,"//,S,//",'Das ist ein Test von FormAus.dWrite1 !');
      FFormAus.dWrite2(Aus,"//,S,F12.6,//",'Das ist die Zahl 2 : ',x);

      FFormAus.dWrite1(Aus,"//,S,//",'Ende der Tests');

      Close(Aus);

      Streams.OpenStream(AusS,"TestS.aus",TRUE); Streams.SetWrite(AusS);

      SIO.WrStr(AusS,"Das ist ein Test !");          SIO.WrLn(AusS);
      SIO.WrStr(AusS,"Das ist ein weiterer Test !"); SIO.WrLn(AusS);
      SIO.WrStr(AusS,"Das ist die Zahl pi : ");
      SIO.WrLngReal(AusS,LongMath.pi,12,7);          SIO.WrLn(AusS);
      SIO.WrStr(AusS,"Das ist falsch : "); 
      x:=1.0E+100*LongMath.pi;
      SIO.WrLngReal(AusS,x,12,7);                    SIO.WrLn(AusS);

      SFormAus.dWrite1(AusS,
      "//,S,//",'Das ist ein Test von SFormAus.dWrite1 !');
      x:=2.0;
      SFormAus.dWrite2(AusS,"//,S,F12.6,//",'Das ist die Zahl 2 : ',x);

      SFormAus.dWrite1(AusS,"//,S,//",'Ende der Tests');

      FOR i:=1 TO 512 DO
        FOR char:="A" TO "Z" DO SIO.WrChar(AusS,char); END;
        FOR char:="a" TO "z" DO SIO.WrChar(AusS,char); END;
        FOR char:="0" TO "9" DO SIO.WrChar(AusS,char); END;
        SIO.WrLn(AusS);
        IF ((i MOD 128) = 0) THEN
          Streams.WriteBuffer(AusS);
          SIO.WrStr(AusS,"Puffer geleert"); SIO.WrLn(AusS);
        END;
      END;

      Streams.CloseStream(AusS);

      (* Lesende Operationen *)

      Streams.OpenStream(AusS,"TestS.aus",FALSE); Streams.SetRead(AusS);
      SFormEin.RdItemF(AusS,Str,10);
      TIO.WrStr("Die ersten 10 Zeichen in TestS.aus sind '"); TIO.WrStr(Str); 
      TIO.WrChar("'"); TIO.WrLn;
      Streams.CloseStream(AusS);

      TIO.WrLn;
      TIO.WrStr("TSIZE(INTEGER)  = "); TIO.WrCard(TSIZE(INTEGER),4);  TIO.WrLn;
      TIO.WrStr("TSIZE(SHORTINT) = "); TIO.WrCard(TSIZE(SHORTINT),4); TIO.WrLn;
      TIO.WrStr("TSIZE(LONGINT)  = "); TIO.WrCard(TSIZE(LONGINT),4);  TIO.WrLn;
      TIO.WrLn;

Errors.Pause(999);
      Name:="Test02.mod";
      Lookup(Aus,Name,FALSE,CAST(OpenMode,OpenMode{openRDONLY}));
      len:=0;
      FileSystem.Length(Aus,len);
Errors.Pause(998);
TIO.WrStr("Ende von FileSystem.Length ... ");
TIO.WrLn;
      TFormAus.Write5("//,S,S,S,C8,S,//",
      "Die Lange der Datei ",Name," ist : ",len," Bytes.");
      Close(Aus);

      (* Einige Tests der String-Routinen ! *)

      Str:="Das ist Test";
      StringsLib.Insert(Str,"ein ",8);
      StringsLib.Append(Str," der Routinen !");
      StringsLib.Insert(Str,"String-",21);
      StringsLib.Concat(Str,Str," ");
(*    StringsLib.Append(Str," "); *)
      TIO.WrChar('"'); TIO.WrStr(Str); TIO.WrChar('"'); TIO.WrLn;
      IF StringsLib.Equal(Str,"Das ist ein Test der String-Routinen ! ") THEN
        TIO.WrStr(" Der Test der String-Routine war erfolgreich !");
      ELSE
        TIO.WrStr(" Der Test der String-Routine war nicht erfolgreich !");
      END;
      TIO.WrLn;

      Errors.Pause(4);
      Errors.WriteString('"');
      Errors.WriteString("Das ist die Zahl pi : ");
      Errors.WriteReal(LongMath.pi);
      Errors.WriteString('"');
      Errors.WriteLn;
      Errors.WriteString('"');
      Errors.WriteString("Das ist die Zahl 231 : ");
      Errors.WriteCard(231);
      Errors.WriteString('"');
      Errors.WriteLn;
      Errors.WriteLn;

      TFormAus.Write3("//,S,A4,S,//",
      "Das ist ein Test des 'An' Formats '","A4       ","'");
      TFormAus.Write3("//,S,A4,S,//",
      "Das ist ein Test des 'An' Formats '","A4","'");

      dT:=DeltaZeitHZr();

      TIO.WrStr("Der Test dauerte "); TIO.WrReal(dT,8,1); 
      TIO.WrStr(" Sekunden"); TIO.WrLn; TIO.WrLn;

END Test02.
