IMPLEMENTATION MODULE UserLib; 

  (*------------------------------------------------------------------------*)
  (* Ermittelt den Benutzernamen des aktuellen Benutzers.                   *)
  (* Fetch the user name of the actual user.                                *)
  (*------------------------------------------------------------------------*)
  (* Letzte Bearbeitung:                                                    *)
  (*                                                                        *)
  (* 28.03.97, MRi.: Durchsicht (m2fanal)                                   *)
  (* 25.09.15, MRi.: GetFullUserName auskommentiert (unsicher)              *)
  (* 19.01.18, MRi.: GetFullUserName mit "Bordmitteln" neu programmiert     *)
  (*------------------------------------------------------------------------*)
  (* Implementation : Michael Riedl                                         *)
  (* Licence        : GNU Lesser General Public License (LGPL)              *)
  (*------------------------------------------------------------------------*)

  (* $Id: UserLib.mod,v 1.3 2018/01/19 14:51:07 mriedl Exp mriedl $ *)

FROM SYSTEM     IMPORT ADR;
FROM UnixLib    IMPORT StrPtr,getlogin;
                IMPORT StringsLib;
(*
FROM TokenLib   IMPORT StringTok,Token;
FROM FileSystem IMPORT File,Lookup,Close,OpenFlags,OpenMode;
                IMPORT FIO2;
 *)

PROCEDURE GetUserName(VAR UserName : ARRAY OF CHAR);

          (* Ermittelt den Login-Namen des Benutzers. *)

          VAR Name : StrPtr;
BEGIN
      Name := getlogin();

      IF (Name = NIL) THEN
        StringsLib.Copy(UserName," ??? ");
      ELSE
        StringsLib.Copy(UserName,Name^);
      END;
END GetUserName;

(*
PROCEDURE GetFullUserName(VAR UserName     : ARRAY OF CHAR;
                          VAR LongUserName : ARRAY OF CHAR);

          VAR PWline  : ARRAY [0..128] OF CHAR;
              NToken  : CARDINAL;
              Tokens  : ARRAY [0..63] OF Token;
              Trenner : ARRAY [0..1] OF CHAR;
              done    : BOOLEAN;
              pwf     : File;
BEGIN
      Lookup(pwf,"/etc/passwd",FALSE,OpenMode{openRDONLY});
      Trenner := ":";
      REPEAT
        FIO2.ReadLine(pwf,PWline);
        StringTok(PWline,Trenner,FALSE,Tokens,NToken,done);
      UNTIL FIO2.EOF OR StringsLib.Equal(Tokens[0],UserName);
      IF NOT FIO2.EOF THEN
        StringsLib.StripTrailing(Tokens[4],",");
        StringsLib.Copy(LongUserName,Tokens[4]);
      ELSE
        LongUserName[0]:=0C;
      END;
      Close(pwf);
END GetFullUserName;
*)
END UserLib.
