/*---------------------------------------------------------------------------*/
/* fslenght : Kann von FileSystem.Length gerufen werden, um die L"ange einer */
/*             Datei zu ermitteln.                                           */
/*                                                                           */
/* Autor            : M. Riedl, Bochum den 08.03.1996                        */
/*                                                                           */
/* Letzte "Anderung :                                                        */
/*                                                                           */
/*   08.03.1996, M.Riedl : Initial version                                   */
/*   11.01.2015, M.Riedl : Changed order of arguments to FileLength to avoid */
/*                         Problems occuring with HIGH parameter handling of */
/*                         different M2 compilers "C" interface              */
/*---------------------------------------------------------------------------*/

#undef debug

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>

void FileLength(unsigned long int *DateiLaenge,
                              int *Fehler,
                char               DateiName[],
                unsigned      int  high)        /* Wegen OPENARRAY-Parameter */

{
      struct stat    StatPuf;

      *Fehler = stat(DateiName, &StatPuf);
      if (*Fehler == -1) {
        /* fprintf(stderr,"\n\nFehler : %s\n\n",strerror(errno)); */
        *DateiLaenge = 0;
      } else {
        *DateiLaenge = StatPuf.st_size;
      }
#ifdef debug
      printf("\nDie Länge der Datei %s ist %lu (FileLength)\n",
             DateiName,*DateiLaenge);
#endif
} /* FileLength */

void SetErrFlag(char Fehlerflag[],
                int  high)

{
      strcpy(Fehlerflag, strerror(errno));
} /* SetErrFlag */

void BEGIN_fslength()

{ /* Leer, f"ur mtc */ }
