#define __debug__

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define MAX_STRING_LENGTH 128
#define MAX_TOKENS         64
#define MAX_DELIM           3

void StringTok(char   Str[MAX_STRING_LENGTH], /* var in,out */
               char   Trenner[MAX_DELIM],     /* var in,out */
               char  *Tokens[MAX_TOKENS],     /* var out    */
               int   *NToken)                 /* var out    */

      /*--------------------------------------------------------------*/
      /* Zerlegt den String Str in die einzelnen Token, wobei in      */
      /* Trenner die Trennzeichen f"ur die einzelnen Token "ubergeben */
      /* werden. In NToken wird die Anzahl der ermittelten Token      */
      /* zur"uckgegeben.                                              */
      /* Die Argumente Str (und Trenner) werden ver"andert !!!        */
      /*--------------------------------------------------------------*/

{
      char   *Tok;
      char   *saveptr1;

      *NToken = 0;
      Tok = strtok_r(Str,Trenner,&saveptr1);
      for (;;) {
        if (Tok == NULL) {
          break;
        }
        Tokens[*NToken] = Tok;
        *NToken=*NToken + 1;
        Tok = strtok_r(NULL,Trenner,&saveptr1);
      }

} /* END StringTok */

void Benutzung(char *progname)

{
      printf("\n\n  Benutzung : %s -D <CompDef>",progname);
      printf("\n\n  Beispiel  : %s -D __XDS__\n\n",progname);
      exit(-1);
}

#ifdef __debug__
int ProcessUntil(char  Until[],
                 int  *ZeilenNr,
                 char  Puffer[MAX_STRING_LENGTH], /* Puffer for line, global  */
                 int   IfWr,
                 FILE *DB_out)                    /* For Debugging purpose    */
#else
int ProcessUntil(char  Until[],
                 int  *ZeilenNr,
                 char  Puffer[MAX_STRING_LENGTH], /* Puffer for line, global  */
                 int   IfWr)
#endif

{
      char   line[MAX_STRING_LENGTH];
      char  *Tokens[MAX_TOKENS];
      int    NToken;
      char   Trenner[MAX_DELIM];
      char  *ReturnCode;
      int    len;
      int    i;
   
#ifdef __debug__
        fprintf(DB_out,"ZeilenNr %d = >>",*ZeilenNr); 
        fputs(Puffer,DB_out);
        fprintf(DB_out,"\n");
        fprintf(DB_out,"Starte ProcessUntil mit IfWr = %d\n",IfWr);
#endif
      for (i=1;;i++) { 
      	ReturnCode=fgets(line,MAX_STRING_LENGTH,stdin);
        if (ReturnCode == NULL) {
          return(1);
        }
        ZeilenNr++;
        len = strlen(line);
        strncpy(Puffer,line,len);
        Puffer[len-1] = 0;
        StringTok(Puffer,Trenner,Tokens,&NToken);
#ifdef __debug__
        fprintf(DB_out,"ZeilenNr %d = >>",*ZeilenNr); 
        fputs(Puffer,DB_out);
        fprintf(DB_out,"<<\n");
        for (i=0;i < NToken;i++) {
          fprintf(DB_out,"Token %d = >>%s<<\n",i,Tokens[i]);
        }
        fprintf(DB_out,"\n");
#endif
        if (strcmp(Tokens[0],Until) == 0) {
          /* Termination condition found */
          break;
        } else {
          if (IfWr == 1) {
            fputs(line,stdout);
          }
        }
      } /* for */
      return(0);
} /* ProcessUntil */

#ifdef __debug__
int CheckLine(char  CompDef[],                 /* Keyword to be locked for */ 
              char  Puffer[MAX_STRING_LENGTH], /* Puffer for line, global  */
              FILE *DB_out)                    /* For Debugging purpose    */
#else
int CheckLine(char  CompDef[],                 /* Keyword to be locked for */ 
              char  Puffer[MAX_STRING_LENGTH]) /* Puffer for line, global  */
#endif

{
      char   line[MAX_STRING_LENGTH];
      char  *Tokens[MAX_TOKENS];
      int    NToken;
      char   Trenner[MAX_DELIM];
      char  *ReturnCode;
      int    EndOfFile = 0;
      int    ZeilenNr = 0;
      int    len;
      int    i;

      strcpy(Trenner," ");

      while (EndOfFile != 1) { 
        ZeilenNr++;
        ReturnCode=fgets(line,MAX_STRING_LENGTH,stdin);

        if (ReturnCode == NULL) {
          EndOfFile = 1;
          return(0);
        }

        len = strlen(line);
        strncpy(Puffer,line,len);
        Puffer[len-1] = 0;
        StringTok(Puffer,Trenner,Tokens,&NToken);

#ifdef __debug__
        fprintf(DB_out,"ZeilenNr %d = >>",ZeilenNr); 
        fputs(Puffer,DB_out);
        fprintf(DB_out,"<<\n");
        for (i=0;i < NToken;i++) {
          fprintf(DB_out,"Token %d = >>%s<<\n",i,Tokens[i]);
        }
        fprintf(DB_out,"\n");
#endif

        if (NToken == 1) {
          fputs(line, stdout);
        } else {
          if (strcmp(Tokens[0],"#ifdef") != 0) {
            fputs(line, stdout);
          } else { /* #ifdef found */
            if (strcmp(Tokens[1],CompDef) == 0) {
              /* Read and write lines until #endif found */
#ifdef __debug__
              fprintf(DB_out,"\n#ifdef mit %s gefunden\n",CompDef);
#endif
              for (i=1;;i++) { 
      	        ReturnCode=fgets(line,MAX_STRING_LENGTH,stdin);
                if (ReturnCode == NULL) {
                  EndOfFile = 1;
                  return(0);
                }
                ZeilenNr++;
                len = strlen(line);
                strncpy(Puffer,line,len);
                Puffer[len-1] = 0;
                StringTok(Puffer,Trenner,Tokens,&NToken);
#ifdef __debug__
                fprintf(DB_out,"ZeilenNr %d = >>",ZeilenNr); 
                fputs(Puffer,DB_out);
                fprintf(DB_out,"<<\n");
                for (i=0;i < NToken;i++) {
                  fprintf(DB_out,"Token %d = >>%s<<\n",i,Tokens[i]);
                }
                fprintf(DB_out,"\n");
#endif
                if (strcmp(Tokens[0],"#else") == 0) {
#ifdef __debug__
                  EndOfFile = ProcessUntil("#endif",&ZeilenNr,Puffer,0,DB_out);
#else
                  EndOfFile = ProcessUntil("#endif",&ZeilenNr,Puffer,0);
#endif
                  if (EndOfFile == 1) {
                    return(0);
                  }
                  break;
                } else if (strcmp(Tokens[0],"#endif") == 0) {
                  break;
                } else {
                  fputs(line,stdout);
                }
              } /* for */
            } else {
              /* Read and do not write lines until #endif or #else found */
#ifdef __debug__
              fprintf(DB_out,"\n#ifdef ohne %s gefunden\n",CompDef);
#endif
              for (i=1;;i++) { 
      	        ReturnCode=fgets(line,MAX_STRING_LENGTH,stdin);
                if (ReturnCode == NULL) {
                  EndOfFile = 1;
                  return(0);
                }
                ZeilenNr++;
                len = strlen(line);
                strncpy(Puffer,line,len);
                Puffer[len-1] = 0;
                StringTok(Puffer,Trenner,Tokens,&NToken);
#ifdef __debug__
                fprintf(DB_out,"ZeilenNr %d = >>",ZeilenNr); 
                fputs(Puffer,DB_out);
                fprintf(DB_out,"<<\n");
                for (i=0;i < NToken;i++) {
                  fprintf(DB_out,"Token %d = >>%s<<\n",i,Tokens[i]);
                }
                fprintf(DB_out,"\n");
#endif
                if (strcmp(Tokens[0],"#else") == 0) {
#ifdef __debug__
                  EndOfFile = ProcessUntil("#endif",&ZeilenNr,Puffer,1,DB_out);
#else
                  EndOfFile = ProcessUntil("#endif",&ZeilenNr,Puffer,1);
#endif
                  if (EndOfFile == 1) {
                    return(0);
                  }
                  break;
                } else if (strcmp(Tokens[0],"#endif") == 0) {
                  break;
                }
              } /* for */
            } /* if CompDef */
          } /* if #ifdef */
        } /* if NToken */
      } /* while (EndOfFile != 1) */
      return(0);
} /* END CheckLine */

int main(int argc, char **argv)

{
      char  CompDef[16];
      char  Puffer[MAX_STRING_LENGTH];
#ifdef __debug__
      FILE *DB_out;

      DB_out = fopen("m2cc.debug","w+");

      fprintf(DB_out,"\nargc  = %d\nArg 0 = %s\nArg1 = %s\nArg2 = %s\n\n",
        argc,argv[0],argv[1],argv[2]);
#endif

      if (argc != 3) {
        Benutzung(argv[0]);
      } else {
        if (strcmp(argv[1],"-D") != 0) {
          Benutzung(argv[0]);
        } else {
          strcpy(CompDef,argv[2]);
        }
      } /* if argc */

#ifdef __debug__
      fprintf(DB_out,"\nEs wird nach Direktive \"%s\" gesucht\n\n",CompDef); 
      CheckLine(CompDef,Puffer,DB_out); /* Parse and process stdin */
#else
      CheckLine(CompDef,Puffer); /* Parse and process stdin */
#endif


#ifdef __debug__
      fclose(DB_out);
#endif

      return 0;

} /* END main */
